# -*- coding:Utf-8 -*-
import es, playerlib, langlib, popuplib
import sw_config as swConfig
import sw_player as swPlayer
import sw_ghoster as swGhoster

## Ouverture du fichier de langue
sw_langue = langlib.Strings(es.getAddonPath("sorrow") + "/configuration/langues.ini")

class Admin:
    def __init__(self, userid):
        self.userid = userid
        self.steamid = es.getplayersteamid(userid)
        self.createMenu()
    def createMenu(self):
        menu = popuplib.create('menuAdmin-%s'%(self.userid)) # Création du menu
        menu.addline("(_________[Sorrow]_________)")
        menu.addline("-------- Menu Admin --------")
        menu.addline("->1. Ghost")
        menu.addline("->2. UnGhost")
        menu.addline("->3. Téléporter")
        menu.addline("->4. Sauvegarder cette position")
        menu.addline("->5. Téléporter un joueur à un autre")
        menu.addline("------------------")
        menu.addline("->0. Sortir")
        menu.menuselect = self.choix_menuAdmin
    def choix_menuAdmin(self, userid, choix, popupid):
        if choix == 1: # Choix 1 - donc celui qui sert à forcer un joueur a etre ghost
            playerlist = PlayerList(self.userid) # instantiation de l'admin dans le module playerlist
            playerlist.createMenu("menuAdmin-%s"%(self.userid), self.choix_menu_joueur, "ghost", 1) # On crée le menu avec la liste des joueurs
            playerlist.sendMenu() # On envoi le menu à l'admin
        elif choix == 2: # Choix 2 - donc celui qui sert à forcer un joueur a etre unghost
            playerlist = PlayerList(self.userid) # instantiation de l'admin dans le module playerlist
            playerlist.createMenu("menuAdmin-%s"%(self.userid), self.choix_menu_joueur, "unghost", 1) # On crée le menu avec la liste des joueurs
            playerlist.sendMenu() # Envoi du menu
        elif choix == 3: # Choix 3 - donc celui qui sert à téléporter un joueur à la position sauvegarder
            joueur = playerlib.getPlayer(userid) # Instantiation de l'admin dans le module playerlib
            player = swPlayer.Player(userid) # Instantiation de l'admin dans le module player
            loc = player.get("savelocation") # Vérifie si l'admin à déjà sauvegardé une position
            if loc == False: # Sinon on lui envoi un message pour lui demander de le faire
                es.tell(userid,"#multi",sw_langue("admin_none_location",lang=joueur.get("lang")))
                popuplib.send(popupid, userid) # Renvoi du menu principale admin
            else: # Sinon on lui envoi la liste des joueurs
                playerlist = PlayerList(self.userid)
                playerlist.createMenu("menuAdmin-%s"%(self.userid), self.choix_menu_joueur, "tp", 1) # création de la liste des joueurs
                playerlist.sendMenu() # envoi de la liste
        elif choix == 4: # Choix 4 - donc celui qui sert à sauvegarder la position
            joueur = playerlib.getPlayer(userid) # module playerlib qui va donner la position du joueur
            (sw_x, sw_y, sw_z) = joueur.get("location") # Création d'un tuple avec les coordonnées du joueur
            vectorString = es.createvectorstring(sw_x, sw_y, sw_z) # Création d'un vecteur
            player = swPlayer.Player(userid) # Instantiation du joueur dans le module player
            player.set("savelocation", vectorString) # Pour sauvegarder sa position dans la base de donnée
            es.tell(userid,"#multi",sw_langue("admin_location_save",lang=joueur.get("lang"))) # Envoi d'un message
            popuplib.send(popupid, userid) # Et renvoi du menu
        elif choix == 5: # Choix 5 - En construction
            self.createMenu() # Création du menu
            self.playerSetTo = [] # List qui va contenir le joueur à téléporter à un autre joueur
            playerlist = PlayerList(self.userid)
            playerlist.createMenu("menuAdmin-%s"%(self.userid), self.choix_menu_joueur, "setto", 0)
            playerlist.sendMenu()
    def choix_menu_joueur(self, userid, type, who): # Fonction où je receptionne tout les choix qui proviennent de la listes des joueurs
        # Arguments - type = ghost, unghost, ... pour savoir ce que je dois faire - who = #single, #all, ... pour savoir à qui le faire
        if who == "#single": # Donc si je dois le faire qu'a une seul personne
            if type == "ghost": # Si je dois le rendre ghost
                msg = {} # Création du message
                msg["admin_name"] = es.getplayername(self.userid)
                msg["player_name"] = es.getplayername(userid)
                for player in playerlib.getUseridList("#all"): # Boucle sur chaque joueur pour les informés qu'un admin a fait telle action
                    joueur = playerlib.getPlayer(player)
                    es.tell(player,"#multi",sw_langue("admin_set_player_ghost",opts=msg,lang=joueur.get("lang")))
                ghost = swGhoster.Ghost(userid) # rend ghost le joueur selectionné
                ghost.ghost()
            elif type == "unghost": # Pareille que précédament
                msg = {}
                msg["admin_name"] = es.getplayername(self.userid)
                msg["player_name"] = es.getplayername(userid)
                for player in playerlib.getUseridList("#all"):
                    joueur = playerlib.getPlayer(player)
                    es.tell(player,"#multi",sw_langue("admin_set_player_unghost",opts=msg,lang=joueur.get("lang")))
                ghost = swGhoster.Ghost(userid)
                ghost.unghost()
            elif type == "tp": # Si je dois téléporter le joueur
                msg = {} # Création du message d'information à tout les joueurs
                msg["admin_name"] = es.getplayername(self.userid)
                msg["player_name"] = es.getplayername(userid)
                for player in playerlib.getUseridList("#all"): # Envoi à chaque joueurs
                    joueur = playerlib.getPlayer(player)
                    es.tell(player,"#multi",sw_langue("admin_tp_player",opts=msg,lang=joueur.get("lang")))
                player = swPlayer.Player(self.userid) # Instantiation du joueur dans le module playerlib pour lui donner la location choisi par l'admin
                self.tp(userid, player.get("savelocation"))
        else: # Si ce n'est pas qu'un joueur je procéde dans le sens inverse
            if type == "ghost": # Je doit les rendre ghost
                msg = {} # Message d'information
                msg["admin_name"] = es.getplayername(self.userid)
                if who == "#all": # Si c'est tout le monde mon message dit que l'admin téléporte tout le monde
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_all_ghost",opts=msg,lang=joueur.get("lang")))
                elif who == "#t": # Ainsi de suite
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_t_ghost",opts=msg,lang=joueur.get("lang")))
                elif who == "#ct": # De meme
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_ct_ghost",opts=msg,lang=joueur.get("lang")))
                for clef in userid: # Boucle sur chaque userid pour les mettre ghost
                    ghost = swGhoster.Ghost(clef)
                    ghost.ghost()
            elif type == "unghost": # Exactement pareille que ghost
                msg = {}
                msg["admin_name"] = es.getplayername(self.userid)
                if who == "#all":
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_all_unghost",opts=msg,lang=joueur.get("lang")))
                elif who == "#t":
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_t_unghost",opts=msg,lang=joueur.get("lang")))
                elif who == "#ct":
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_set_ct_unghost",opts=msg,lang=joueur.get("lang")))
                for clef in userid:
                    ghost = swGhoster.Ghost(clef)
                    ghost.unghost()
            elif type == "tp": # Si je doit téléporter
                msg = {} # Message d'information
                msg["admin_name"] = es.getplayername(self.userid)
                if who == "#all": # Si c'est tout le monde que je téléporte
                    for player in playerlib.getUseridList("#all"): # Boucle sur chaque joueur pour leur envoyé le message
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_tp_all",opts=msg,lang=joueur.get("lang")))
                    for clef in userid: # Boucle sur chaque id
                        ghost = swGhoster.Ghost(clef) # Les rends ghost pour qu'ils ne se bloquent pas ;)
                        ghost.ghost()
                        player = swPlayer.Player(self.userid) # Et leur donne une nouvelle position
                        self.tp(clef, player.get("savelocation"))
                elif who == "#t": # Pareille mais que pour les ct
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_tp_t",opts=msg,lang=joueur.get("lang")))
                    for clef in userid:
                        ghost = swGhoster.Ghost(clef)
                        ghost.ghost()
                        player = swPlayer.Player(self.userid)
                        self.tp(clef, player.get("savelocation"))
                elif who == "#ct": # Pareille pour les ct
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        es.tell(player,"#multi",sw_langue("admin_tp_ct",opts=msg,lang=joueur.get("lang")))
                    for clef in userid:
                        ghost = swGhoster.Ghost(clef)
                        ghost.ghost()
                        player = swPlayer.Player(self.userid)
                        self.tp(clef, player.get("savelocation"))
        if type == "setto": # Si je dois téléporter un joueur a un autre
            if len(self.playerSetTo) == 1 and who != "#single":
                joueur = playerlib.getPlayer(self.userid)
                es.tell(self.userid,"#multi",sw_langue("admin_set_player_to_player_cible_choix_not_all-ct-t",lang=joueur.get("lang")))
            else:
                if len(self.playerSetTo) != 2 and len(self.playerSetTo) != 1 and who != "#single":
                    self.playerSetTo.append(who)
                elif len(self.playerSetTo) != 2 and who == "#single":
                    self.playerSetTo.append(userid)
                if len(self.playerSetTo) != 2:
                    playerlist = PlayerList(self.userid)
                    playerlist.createMenu("menuAdmin-%s"%(self.userid), self.choix_menu_joueur, "setto", 0)
                    playerlist.sendMenu()
                if len(self.playerSetTo) == 2:
                    msg = {} # Création du message d'information
                    msg["admin_name"] = es.getplayername(self.userid)
                    msg["player_cible"] = es.getplayername(self.playerSetTo[1])
                    for player in playerlib.getUseridList("#all"):
                        joueur = playerlib.getPlayer(player)
                        if self.playerSetTo[0] == "#all":
                            es.tell(player,"#multi",sw_langue("admin_set_all_to_player",opts=msg,lang=joueur.get("lang")))
                        elif self.playerSetTo[0] == "#t":
                            es.tell(player,"#multi",sw_langue("admin_set_t_to_player",opts=msg,lang=joueur.get("lang")))
                        elif self.playerSetTo[0] == "#ct":
                            es.tell(player,"#multi",sw_langue("admin_set_ct_to_player",opts=msg,lang=joueur.get("lang")))
                        elif who == "#single":
                            msg["player_tp"] = es.getplayername(self.playerSetTo[0])
                            es.tell(player,"#multi",sw_langue("admin_set_player_to_player",opts=msg,lang=joueur.get("lang")))
                    if self.playerSetTo[0] == "#all" or self.playerSetTo[0] == "#ct" or self.playerSetTo[0] == "#t":
                        if self.playerSetTo[0] == "#all":
                            playerlist = playerlib.getUseridList("#alive,#all")
                        elif self.playerSetTo[0] == "#t":
                            playerlist = playerlib.getUseridList("#alive,#t")
                        elif self.playerSetTo[0] == "#ct":
                            playerlist = playerlib.getUseridList("#alive,#ct")
                        for clef in playerlist:
                            playertomove = playerlib.getPlayer(clef)
                            playertomove.set("moveto", self.playerSetTo[1])
                    else:
                        playertomove = playerlib.getPlayer(self.playerSetTo[0])
                        playertomove.set("moveto", self.playerSetTo[1])
                    popuplib.send("menuAdmin-%s"%(self.userid), self.userid)
                    del(self.playerSetTo)
    def sendMenu(self):
        popuplib.send("menuAdmin-%s"%(self.userid), self.userid) # Envoi du menu admin
    def tp(self, userid, loc): # Fonction rapide pour téléporter
        (sw_x, sw_y, sw_z) = es.splitvectorstring(loc)
        joueur = playerlib.getPlayer(userid)
        joueur.set("location", [ sw_x, sw_y, sw_z ])

class PlayerList:
    def __init__(self, userid):
        self.userid = userid
        self.steamid = es.getplayersteamid(userid)
        self.player_choix = {} # Dico qui va contenir le joueur est son choix dans la page
        self.player_popupid = {} # Dico qui va contenir le joueur est son numéro de page
    def createMenu(self, oldmenu, function, type, resend): # Création du menu
        self.oldmenu = oldmenu # Me sert à faire un "retour"
        self.function = function # Fonction à appellé pour chaque choix
        self.type = type # Me sert à savoir l'action a faire une fonction la selection du / des joueurs faite
        self.resend = resend # Sert a savoir si je doit relancer le menu a chaque choix
        max_choice = 4 # Début des choix (car les 3 premiers sont Tous / CT / T)
        total_choice = 0 # Maximum de choix au total
        popup_num = 1 # Numéro de la page
        menu = popuplib.create('menuPlayer-%s_%s'%(self.userid,popup_num)) # Création du menu
        menu.addline("(      [Sorrow]      )")
        menu.addline("------ Listes Des Joueurs ------(Page : %s)"%(popup_num))
        menu.addline("->1. Tous les joueurs") # Ici les 3 premiers choix spéciaux
        menu.addline("->2. Tous les terroristes")
        menu.addline("->3. Tous les CT")
        player_list = playerlib.getUseridList("#all,#alive") # Récupére la liste des joueurs vivants
        for clef in player_list: # Boucle sur chaque joueurs
            self.player_choix[clef] = max_choice # Ajoute le joueur dans le dico avec son choix
            self.player_popupid[clef] = popup_num # ajoute le jouer dans le dico avec son numéro de page
            player_name = es.getplayername(clef) # Récupére son nom
            player_team = es.getplayerteam(clef) # Récupére sa team
            if player_team == 2:
                team_name = "T"
            elif player_team == 3:
                team_name = "CT"
            menu.addline("->%s. %s [%s]"%(self.player_choix[clef], player_name, team_name)) # Ajoute la ligne du joueur dans le menu
            max_choice += 1 # Incrémente les choix de 1
            total_choice += 1 # Incrémente le nombre de choix total de 1
            if max_choice == 8 or total_choice == len(player_list): # Si sur cette page il y a 8 choix ou que le nombre total de choix est égale au nombre de joueur dans la liste
                menu.addline("------------------") # On termine le menu
                menu.addline("->8. Retour")
                max_choice = 1 # Remet a 1 (et non a 4 car sur la prochaine page on aura plus les 3 choix spéciaux) max_choice
                if total_choice != len(player_list): # Si le nombre total de choix n'est pas égale à la taille de la liste des joueurs
                    popup_num += 1 # Incrémente le numéro de page
                    menu.addline("->9. Suivant") # Termine le menu
                    menu.addline("->0. Sortir")
                    menu.menuselect = self.choix_menu_player
                    menu = popuplib.create('menuPlayer-%s_%s'%(self.userid,popup_num)) # Créer la prochaine page
                    menu.addline("(      [Sorrow]      )")
                    menu.addline("------ Listes Des Joueurs ------(Page : %s)"%(popup_num))
                else: # Sinon on ferme le menu
                    menu.addline("->0. Sortir")
                    menu.menuselect = self.choix_menu_player
    def choix_menu_player(self, userid, choix, popupid): # Ici je récupére le choix du menu
        id_popup = popupid.split("_") # Numéro de la page
        if choix != 8 and choix != 9 and choix != 10 and choix != 1 and choix != 2 and choix != 3 and int(id_popup[1]) == 1: # Si les choix ne sont pas 9 - 8 - 10 (choix spéciaux des popups) ou 1 - 2 - 3 (choix spéciaux de la listes) et que le numéro de page est 1
            for clef in self.player_choix: # boucle sur chaque joueur de ma liste de choix
                if int(choix) == int(self.player_choix[clef]) and int(id_popup[1]) == int(self.player_popupid[clef]): # Si le choix est égale à celui du joueur et que le numéro de la page est égale a celui du joueur
                    self.function(clef, self.type, "#single") # Apelle la fonction de l'utilisateur du module et lui renvoi les informations
            if self.resend == 1:
                self.createMenu(self.oldmenu, self.function, self.type, self.resend) # Et je renvoi la meme page
                self.sendMenu()
        elif choix != 8 and choix != 9 and choix != 10 and int(id_popup[1]) != 1: # Si les choix ne sont pas les choix spéciaux des popups et que le numéro de pages n'est pas égale a 1
            for clef in self.player_choix: # Boucle sur chaque joueur de ma liste de choix
                if int(choix) == int(self.player_choix[clef]) and int(id_popup[1]) == int(self.player_popupid[clef]): # Si le choix est égale à celui du joueur et que le numéro de la page est égale a celui du joueur
                    self.function(clef, self.type, "#single") # Apelle de la fonction utilisateur
            if self.resend == 1:
                self.createMenu(self.oldmenu, self.function, self.type, self.resend) # Renvoi de la meme page
                self.sendMenu()
        elif choix == 9: # Choix 9 - donc suivant
            next_page = int(id_popup[1]) + 1 # Incrémente le numéro de page
            next_page_exists = False # Bool pour vérifié si la page existe
            for clef in self.player_popupid: # Boucle sur chaque joueur et leur numéro de page
                if self.player_popupid[clef] == next_page: # Si un joueur correspond au numéro de page
                    next_page_exists = True # Alors la page existe
            if next_page_exists == True: # Et on peu l'envoyer
                popuplib.send("menuPlayer-%s_%s"%(self.userid,next_page), userid)
            else: # Sinon on renvoi la meme page
                popuplib.send(popupid, userid)
        elif choix == 8: # Choix 8 - donc précédent
            previous_page = int(id_popup[1]) - 1 # Décrémentation du numéro de page
            if previous_page != 0: # Si le numéro de page n'est pas 0
                previous_page_exists = False # Bool de vérification
                for clef in self.player_popupid: # Boucle sur chaque joueur et leur page
                    if self.player_popupid[clef] == previous_page: # Si un joueur correspond
                        previous_page_exists = True # La page existe
                if previous_page_exists == True: # On l'envoi
                    popuplib.send("menuPlayer-%s_%s"%(self.userid,previous_page), userid)
            else:
                popuplib.send(self.oldmenu, userid) # Sinon on renvoi le menu de l'utilisateur
        elif choix == 1 and int(id_popup[1]) == 1: # Si le choix est 1 et que le numéro de page est 1
            self.function(playerlib.getUseridList("#all,#alive"), self.type, "#all") # On apelle la fonction utilisateur avec la liste de tout les joueurs et on le précise
            if self.resend == 1:
                es.msg("Resend")
                self.createMenu(self.oldmenu, self.function, self.type, self.resend) # Renvoi de la page
                self.sendMenu()
        elif choix == 2 and int(id_popup[1]) == 1: # Si le choix est 2 et numéro de page 1
            self.function(playerlib.getUseridList("#t,#alive"), self.type, "#t") # On fait de meme mais pour tout les Terro en vie
            if self.resend == 1:
                self.createMenu(self.oldmenu, self.function, self.type, self.resend)
                self.sendMenu()
        elif choix == 3 and int(id_popup[1]) == 1: # De meme
            self.function(playerlib.getUseridList("#ct,#alive"), self.type, "#ct") # Avec les ct en vie
            if self.resend == 1:
                self.createMenu(self.oldmenu, self.function, self.type, self.resend)
                self.sendMenu()
    def sendMenu(self):
        popuplib.send("menuPlayer-%s_1"%(self.userid), self.userid) # Envoi de la premiére page